// JeeLink code for the model rocket telemetry
// 
// 648.ken@gmail.com
// bugled.blogspot.com


#include <Ports.h>
#include <RF12.h>

typedef struct { // 14 bytes
        uint16_t ms;
	int16_t accel;
	int16_t pres;
} Payload;
Payload values;
boolean ACK;
boolean VERBOSE = false;

void setup () {
    Serial.begin(57600);
    if (VERBOSE) {Serial.println("\n[rocket_REC.pde]");}
    rf12_initialize(1, RF12_915MHZ, 212); // 915 Mhz, net group 212, node 1
}


void loop () {
  checkSerial();
  if (rf12_recvDone() && rf12_crc == 0 && rf12_len == sizeof (Payload)) {
      Payload* values = (Payload*) rf12_data;
      Serial.print(values->ms);
      Serial.print(',');
      Serial.print(values->accel);
      Serial.print(',');
      Serial.print(values->pres);
      Serial.println(',');
  }
}


void checkRecieved(){
  byte n = rf12_len;
  if (rf12_recvDone() && rf12_crc == 0 && rf12_len > 0){
    if (VERBOSE){
      Serial.print("incomming -> ");
      Serial.print((int) rf12_hdr);
      if (rf12_data[0] == 119) {ACK = true;}
      for (byte i = 0; i < n; ++i) {
          Serial.print(' ');
          Serial.print((int) rf12_data[i]);
      }
    }
  }
}


void checkSerial(){
  if (Serial.available()>0){
    int incomingByte = Serial.read();
    while (!rf12_canSend())
      if (rf12_recvDone()){ checkRecieved();}
    rf12_sendStart(2, &incomingByte, 1, 1);
    if (VERBOSE) {
      Serial.print(char(incomingByte));
      Serial.println(" sent!");
    }
  }
}



